package pl.afizyka.wyborjednejwartoscispinner

import android.annotation.SuppressLint
import android.content.Context
import android.os.Bundle
import android.view.View
import android.widget.AdapterView
import android.widget.ArrayAdapter
import android.widget.Button
import android.widget.EditText
import android.widget.Spinner
import android.widget.TextView
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity

class MainActivity : AppCompatActivity() {
    var idWyboru=-1;
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        WypelnijSpinnera()
        ObslugaSpinera()
        val bt1=findViewById<Button>(R.id.button)
        bt1.setOnClickListener {
            Oblicz(idWyboru)
        }
        val bt2=findViewById<Button>(R.id.button2)
        bt2.setOnClickListener {
            LadujNiestandardowe()
            ObslugaSpineraNiestandardowaLista(this)
        }
    }

    fun WypelnijSpinnera(){
        val tabDzialan=resources.getStringArray(R.array.dzialania)
        val adapter=ArrayAdapter<String>(
            this,
            //android.R.layout.simple_spinner_item,
            android.R.layout.simple_spinner_dropdown_item,
            tabDzialan
        )
        val spinner=findViewById<Spinner>(R.id.spinner)
        spinner.adapter=adapter
        //ustaw aktywne działanie na dzielenie
        spinner.setSelection(3)
    }
    fun ObslugaSpinera(){
        val spinner=findViewById<Spinner>(R.id.spinner)
        spinner.onItemSelectedListener = object : AdapterView.OnItemSelectedListener {
            override  fun  onItemSelected (parent: AdapterView <*>, view: View ?, position: Int , id: Long ) {
                idWyboru=position
            }
            override  fun  onNothingSelected (parent: AdapterView <*>) {
                // Nic nie rób
            }
        }
    }

    fun Oblicz(id: Int){
        val aTxt=findViewById<EditText>(R.id.editTextNumber1)
        val bTxt=findViewById<EditText>(R.id.editTextNumber2)
        if(aTxt.text.toString()==""||bTxt.text.toString()=="")return
        val a=aTxt.text.toString().toDouble()
        val b=bTxt.text.toString().toDouble()
        val wynik=findViewById<TextView>(R.id.textView2)
        when(id){
            0->wynik.setText((a+b).toString())
            1->wynik.setText((a-b).toString())
            2->wynik.setText((a*b).toString())
            //przykład formatowania wyniku do trzech miejsc po przecinku
            3->wynik.setText(String.format("%.3f",a/b))
        }
    }
    //ukry komunikaty pozornego błędu indeksu
    @SuppressLint("ResourceType")
    fun LadujNiestandardowe(){
        val tabDzialan=resources.obtainTypedArray(R.array.TablicaDzialan)
        var listaDzialan= mutableListOf<PrzekazywaneDane>()
        for(i in 0..tabDzialan.length()-1){
            val tabBufor=resources.obtainTypedArray(tabDzialan.getResourceId(i,0))
            listaDzialan.add(
                PrzekazywaneDane(
                    tabBufor.getString(0).toString(),
                    tabBufor.getResourceId(1,R.drawable.plus)
                )
            )
        }
        val spinner=findViewById<Spinner>(R.id.spinner)
        spinner.adapter=MojAdapterSpinnera(this,R.layout.moj_spinner_layout,listaDzialan)
    }
    fun ObslugaSpineraNiestandardowaLista(context:Context){
        val spinner=findViewById<Spinner>(R.id.spinner)
        spinner.onItemSelectedListener = object : AdapterView.OnItemSelectedListener {
            override  fun  onItemSelected (parent: AdapterView <*>, view: View ?, position: Int , id: Long ) {
                idWyboru=position
                val wybranyItem=parent.getItemAtPosition(position)as PrzekazywaneDane
                val oknoKomunikatu=AlertDialog.Builder(context)
                oknoKomunikatu.setTitle("Wybrano działanie")
                oknoKomunikatu.setMessage(wybranyItem.nazwaDzalania)
                oknoKomunikatu.setIcon(wybranyItem.ikonaDzialania)
                oknoKomunikatu.setPositiveButton("Zamknij",null)//{okno,_->okno.dismiss()}
                oknoKomunikatu.create()
                oknoKomunikatu.show()
            }
            override  fun  onNothingSelected (parent: AdapterView <*>) {
                // Nic nie rób
            }
        }
    }
}




