package pl.afizyka.wyborjednejwartoscispinner

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.ImageView
import android.widget.SpinnerAdapter
import android.widget.TextView

class MojAdapterSpinnera(val context: Context, val zasobWidoku: Int,val itemy: List<PrzekazywaneDane>) :
    BaseAdapter(),SpinnerAdapter {
    //zwróć rozmiar listy elementów (itemów)
    override fun getCount(): Int = itemy.size
    //zwroc dane elementu z indeksu pozycji listy
    override fun getItem(position: Int): Any = itemy[position]
    //zwroć identyfikator elementu z listy
    override fun getItemId(position: Int): Long = position.toLong()
    //obsłuz ładowany układ widoku itemu
    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {

        val layout: LayoutInflater = LayoutInflater.from(context)
        val view: View = layout.inflate(zasobWidoku, null)

        val img: ImageView = view.findViewById(R.id.imgDzialanie)
        val txtDzialanie: TextView = view.findViewById(R.id.txtDzialanie)
        val dane: PrzekazywaneDane = itemy[position]
        img.setImageDrawable(context.resources.getDrawable(dane.ikonaDzialania))
        txtDzialanie.text = dane.nazwaDzalania
        return view
        }
    }
//klas posredniczaca w przekazywaniu danych do itemów adaptera
class PrzekazywaneDane(val nazwaDzalania:String, val ikonaDzialania:Int)
